package dbtypes

import (
	"database/sql"
)

type UserType int

const (
	User_Not_Auth UserType = iota
	User_Normal
	User_Admin
)

type User struct {
	Id       string `db:"u.id"`
	Username string `db:"u.username"`
	Email    string `db:"u.email"`
	UserType int    `db:"u.user_type"`
}

func UserFromToken(db *sql.DB, token string) (*User, error) {

	var user User

	err := GetDBOnce(db, &user, "users as u inner join tokens as t on t.user_id = u.id where t.token = $1;", token)
	if err != nil {
		return nil, err
	}

	return &user, nil
}
